---
import Logo from "../components/Logo.astro";
---

<header
  id="landing-header"
  class="py-2 px-10 flex items-center fixed top-0 w-full justify-between text-white z-40"
>
  <div class="flex flex-grow basis-0">
    <a href="./"><Logo /></a>
  </div>

  <nav>
    <ul
      class="flex text-sm [&>li>a]:transition-colors [&>li>a]:duration-300 [&>li>a]:text-current [&>li>a]:inline-block [&>li>a]:font-medium [&>li>a]:px-2 [&>li>a]:py-2"
    >
      <li><a href="#">Doble vistas</a></li>
      <li><a href="#">Doble jardin</a></li>
      <li><a href="#">Doble</a></li>
      <li><a href="#">Triple vistas</a></li>
      <li><a href="#">Triple</a></li>
      <li><a href="#">Familiar</a></li>
    </ul>
  </nav>

  <nav class="flex flex-grow basis-0 justify-end">
    <ul
      class="flex text-sm [&>li>a]:transition-colors [&>li>a]:duration-300 [&>li>a]:text-current [&>li>a]:inline-block [&>li>a]:font-medium [&>li>a]:px-2 [&>li>a]:py-2"
    >
      <li><a href="#">La masia</a></li>
      <li><a href="#">Packs y ofertas</a></li>
      <li><a href="#">Entorno</a></li>
      <li><a href="#">Contacto</a></li>
    </ul>
  </nav>

  <div
    id="menu-backdrop"
    class={`
      absolute bg-black/5 backdrop-blur-lg rounded
      translate-x-[var(--left)] translate-y-[var(--top)]
      left-0 top-0
      w-[var(--width)] h-[var(--height)]
      transition-all duration-400
      ease-in-out opacity-0 -z-10
    `}
  >
  </div>
</header>

<script>
  const listItem = document.querySelectorAll("#landing-header li");
  const menuBackDrop = document.querySelector("#menu-backdrop") as HTMLElement;

  listItem.forEach((item) => {
    item.addEventListener("mouseenter", () => {
      const { left, top, width, height } = item.getBoundingClientRect();

      menuBackDrop.style.setProperty("--left", `${left}px`);
      menuBackDrop.style.setProperty("--top", `${top}px`);
      menuBackDrop.style.setProperty("--width", `${width}px`);
      menuBackDrop.style.setProperty("--height", `${height}px`);

      menuBackDrop.style.opacity = "1";
      menuBackDrop.style.visibility = "visible";
    });

    item.addEventListener("mouseleave", () => {
      menuBackDrop.style.opacity = "0";
      menuBackDrop.style.visibility = "hidden";
    });
  });
</script>

<script>
  const $header = document.querySelector("#landing-header") as HTMLElement;
  const observerOptions = {
    root: null,
    rootMargin: "0px",
    threshold: 0.9,
  };

  const observer = new IntersectionObserver((entries) => {
    entries.forEach((entry) => {
      const { isIntersecting } = entry;
      if (isIntersecting) {
        const color = entry.target.getAttribute("data-header-color");
        $header.style.color = color;
      }
    });
  }, observerOptions);

  const $sections = document.querySelectorAll(".landing-section");
  $sections.forEach((section) => observer.observe(section));
</script>
